#ifndef _CHECK_H_
#define _CHECK_H_

void checkA
(
    PPcom     *I,
    int location, /* = 1 if dead rows are still present, = 0 otherwise */
    char  *where
) ;

void check_AFT
(
    PPcom    *I,
    int  use_ir,  /* TRUE means skip deleted rows */
    char *where
) ;

void check_AT
(
    PPcom    *I,
    char *where
) ;

void check_back
(
    PPcom        *I,
    double *forward,
    double      *dl,
    INT      botblk,
    char     *where
) ;

void checkb
(   
    PPcom    *I,
    char *where
) ;

void checkc
(   
    PPcom    *I,
    char *where
) ;

void check_const
(   
    double   *x,
    double   cx,
    int      *y,
    int      cy,
    INT       n,
    char *where
) ;

void checkD
(   
    PPcom     *I,
    char  *where
) ;

void check_diag3
(   
    PPcom   *I,
    INT toprow,
    INT botrow,
    int   chol  /* T => the matrix was factorized, otherwise updates */
) ;

void check_diag 
(
    PPcom    *I,
    int    chol,
    char *where
) ;

double check_dual /* return dual objective at current point */
(   
    PPcom    *I,
    double  *dl,
    char *where,
    int    save, /* TRUE => saves dual objective value */
    int   check  /* TRUE => check for increase in dual objective */
) ;

double check_dualsimple /* return dual objective at current point */
(
    PPcom    *I,
    double  *dl
) ;

void check_eqn5
(
    PPcom        *I,
    int      botblk,
    double      *dl,
    double *forward,
    double       *r,
    char     *where
) ;

void check_forward
(
    PPcom        *I,
    double *forward,
    double       *r,
    int    *joblist,
    int          nj,
    char     *where
) ;

void check_line
(
    PPcom        *I,
    int        flag, /* flag = 1 if line search terminates at nondiff point
                        flag = 2 if sd <= 0
                        flag =-1 if stepsize truncated to st = 1 */
    INT      botblk,
    int     updates, /* number of updates to be performed */
    double      *dl, /* direction vector */
    double       st  /* stepsize */
) ;

void check_link
(   
    PPcom     *I,
    int *joblist,
    int       nj,
    char  *where
) ;

void check_minheap
(   
    int   *heap,
    double   *x,  
    int     *ns,
    int   nheap,
    int    ntot,
    char *where
)  ;

void check_modlist
(   
    PPcom    *I,
    char *where
) ;

void check_order
(   
    double   *x,
    INT      *I,
    INT  length,
    char *where
) ;

void checkF
(
    PPcom     *I,
    char  *where
) ;

void check_deriv
(
    PPcom        *I,
    INT      botblk,
    double      *dl, /* direction vector */
    double       st  /* stepsize */
) ;

#endif
