/* ========================================================================= */
/* === check_AT ============================================================ */
/* ========================================================================= */

#include "pproj.h"
void check_AT
(
    PPcom    *I,
    char *where
)
{
    INT i, n, nrow, ncol, p, *Tp, *Ti, *Ap, *Ai, *ATp, *ATi, *Wi ;
    double *Tx, *Ax, *ATx ;

    PPprob *Prob ;
    PPwork    *W ;

#ifdef NDEBUG
    fprintf (stderr, "Debugging is on!\n") ; abort () ;
#endif
    printf ("check AT %s\n", where) ;

    Prob = I->Prob ;
    nrow = Prob->nrow ;
    ncol = Prob->ncol ;
    Ap   = Prob->Ap ;
    Ai   = Prob->Ai ;
    Ax   = Prob->Ax ;

    W = I->Work ;
    ATp = W->ATp ;
    ATi = W->ATi ;
    ATx = W->ATx ;

    /* allocate temporary workspace */
    Tp = (INT *) malloc ((nrow+1)*sizeof (INT)) ;
    n = Ap [ncol] ;
    Ti = (INT *) malloc (n*sizeof (INT)) ;
    Tx = (double *) malloc (n*sizeof (double)) ;
    Wi = (INT *) malloc (nrow*sizeof (INT)) ;

    pproj_transpose (Tp, Ti, Tx, Ap, Ai, Ax, nrow, ncol, Wi) ;

    /* Check Tp */
    for (i = 0; i <= nrow; i++)
    {
        if ( Tp [i] != ATp [i] )
        {
            PRINTF ("Column pointers wrong, i: %i, Tp: %i, ATp: %i\n",
            i, Tp [i], ATp [i]) ;
            pproj_error (-1, __FILE__, __LINE__, where) ;
        }
    }

    /* Check Tx and Ti */
    for (p = 0; p < n; p++)
    {
        if ( Tx [p] != ATx [p] )
        {
            PRINTF ("ATx != transpose Ax p: %i, Tx: %e, ATx: %e\n",
                p, Tx [p], ATx [p]) ;
            pproj_error (-1, __FILE__, __LINE__, where) ;
        }
        if ( Ti [p] != ATi [p] )
        {
            PRINTF ("ATi != transpose Ai p: %i, Ti: %i, ATi: %i\n",
                p, Ti [p], ATi [p]) ;
            pproj_error (-1, __FILE__, __LINE__, where) ;
        }
    }
    free (Tp) ;
    free (Ti) ;
    free (Tx) ;
    free (Wi) ;
}
