/* ========================================================================= */
/* === check_back ========================================================== */
/* ========================================================================= */

#include "pproj.h"
void check_back
(
    PPcom        *I,
    double *forward,
    double      *dl,
    INT      botblk,
    char     *where
)
{
    INT *row_start, *leftdesc, *Lp, *Li, *Lnz, *ir,
         topblk, toprow, botrow, i, j, p, q ;
    int ni ;
    double *Lx, *dlambda, mx, t, s ;
    cholmod_factor *L ;
    PPwork         *W ;

#ifdef NDEBUG
    fprintf (stderr, "Debugging is on!\n") ; abort () ;
#endif
    printf ("check back %s\n", where) ;

    W = I->Work ;
    dlambda = W->dlambda;
    ir = W->ir ;

    ni = I->Prob->ni ;

    L    = W->L ;
    Lp   = L->p ;
    Lnz  = L->nz ;
    Li   = L->i ;
    Lx   = L->x ;
    /* nrow = L->n ; */

    leftdesc = W->leftdesc ;
    row_start = W->row_start ;
    botrow = row_start [botblk+1] ;
    topblk = leftdesc [botblk] ;  /* blks in range topblk:botblk */
    toprow = row_start [topblk] ;

    s = mx = ZERO ;
    for (j = toprow; j < botrow; j++)
    {
        if ( ir [j] <= ni )
        {
            p = Lp [j] ;
            q = p + Lnz [j] ;
            t = forward [j] / Lx [p] ;	/* divide by D(j,j) */
            mx = MAX (mx, fabs (t)) ;
            mx = MAX (mx, fabs (dlambda [j])) ;
            t -= dl [j] ;
            for (p++ ; p < q ; p++)
            {
                i = Li [p] ;
                if ( i >= botrow ) break ;
                t -= dl [i] * Lx [p] ;
            }
            s += fabs (t) ;
        }
    }

    if ( mx != ZERO )
    {
        s /= mx ;
        if ( I->Parm->PrintLevel > 1 )
        {
            PRINTF ("err in backsolve: %e mx: %e\n", s, mx);
        }
        if ( s > 1.e-6 )
        {
            PRINTF ("err in backsolve: %e mx: %e\n", s, mx);
            pproj_error (-1, __FILE__, __LINE__, where) ;
        }
    }
}
