/* ========================================================================== */
/* === check_minheap ======================================================== */
/* ========================================================================== */

#include "pproj.h"
void check_minheap
(
    int   *heap,
    double   *x,
    int     *ns,
    int   nheap,
    int    ntot,
    char *where
)
{
    int j, k ;

#ifdef NDEBUG
    fprintf (stderr, "Debugging is on!\n") ; abort () ;
#endif
    printf ("check minheap %s\n", where) ;

    for (k = 1; k <= nheap; k++)
    {
        if ( (heap [k] < 0) || (heap [k] >= ntot) )
        {
            PRINTF ("heap [%i]: %i, out of range 0 to ntot = %i\n",
                k, heap [k], ntot) ;
            pproj_error (-1, __FILE__, __LINE__, where) ;
        }
    }
    for (k = 1; k <= nheap; k++)
    {
        j = heap [k] ;
        if ( ns [j] != k )
        {
            PRINTF ("ns [%i]: %i, heap [%i]: %i\n", j, ns [j], k, heap [k]) ;
            pproj_error (-1, __FILE__, __LINE__, where) ;
        }
    }
    j = 1 ;
    for (;;)
    {
        k = 2*j ;
        if ( k > nheap ) break ;
        if ( x [heap [k]] < x [heap [j]] )
        {
            PRINTF (
                "messed up at: j: %i (heap: %i x: %e) k: %i (heap: %i x: %e)\n",
                 j, heap [j], x [heap [j]], k, heap [k], x [heap [k]]) ;
     
            for (j = 0; j <= 27; j++)
            {
                PRINTF ("j: %i heap: %i x: %e\n", j, heap [j], x [j]) ;
            }
            pproj_error (-1, __FILE__, __LINE__, where) ;
        }
        k = 2*j + 1 ;
        if ( k > nheap ) break ;
        if ( x [heap [k]] < x [heap [j]] )
        {
            PRINTF (
                "messed up at: j: %i (heap: %i x: %e) k: %i (heap: %i x: %e)\n",
                 j, heap [j], x [heap [j]], k, heap [k], x [heap [k]]) ;
     
            for (j = 0; j <= 27; j++)
            {
                PRINTF ("j: %i heap: %i x: %e\n", j, heap [j], x [j]) ;
            }
            pproj_error (-1, __FILE__, __LINE__, where) ;
        }
        j++ ;
    }
}
